#if !defined(__FLLOPFILE_H)
#define __FLLOPFILE_H
#include "permonmat.h"

typedef enum {DISTRIBUTION_VERTICAL=0, DISTRIBUTION_HORIZONTAL=1} MatFileDistType;

FLLOP_EXTERN char Fllop_input_dir[FLLOP_MAX_PATH_LEN], Fllop_output_dir[FLLOP_MAX_PATH_LEN];

FLLOP_EXTERN PetscErrorCode FllopFileSetPartitionNumberingBase(PetscInt numBase);
FLLOP_EXTERN PetscErrorCode FllopFileSetInputDir(const char dir[]);
FLLOP_EXTERN PetscErrorCode FllopFileSetOutputDir(const char dir[]);
FLLOP_EXTERN PetscErrorCode FllopFileSetAutoOutputDir();
FLLOP_EXTERN PetscErrorCode FllopFileSetFromOptions();

FLLOP_EXTERN PetscErrorCode VecLoadBinary(const char fullPath[], Vec *vec);
FLLOP_EXTERN PetscErrorCode VecLoadBinaryByName(const char objName[], Vec *vec);
FLLOP_EXTERN PetscErrorCode VecLoadBinaryByNameToExisting(Vec vec);
FLLOP_EXTERN PetscErrorCode VecLoadBinaryLocal(MPI_Comm comm, const char objName[], Vec *vec);
FLLOP_EXTERN PetscErrorCode VecLoadBinaryGlobal(MPI_Comm comm, const char objName[], Vec *vec);
FLLOP_EXTERN PetscErrorCode VecSaveBinary(const char fullPath[], Vec vec);
FLLOP_EXTERN PetscErrorCode VecSaveBinaryByName(Vec vec);
FLLOP_EXTERN PetscErrorCode VecSaveBinaryLocal(MPI_Comm comm, Vec vec);

FLLOP_EXTERN PetscErrorCode MatLoadBinary(const char fullPath[], const MatType matType, Mat *mat);
FLLOP_EXTERN PetscErrorCode MatLoadBinaryByName(const char objName[], const MatType matType, Mat *mat);
FLLOP_EXTERN PetscErrorCode MatLoadBinaryLocal(MPI_Comm comm, const char objName[], const MatType matType, Mat *mat);
FLLOP_EXTERN PetscErrorCode MatLoadBinaryGlobal(MPI_Comm comm, const char objName[], const MatType matType, MatInvType blockdiag, PetscBool transposed, MatFileDistType distribution, Vec layout,													  Mat *mat);
FLLOP_EXTERN PetscErrorCode MatLoadBinaryGlobal2(MPI_Comm comm, const char objName[], const MatType matType,MatInvType blockdiag, PetscBool transposed, MatFileDistType distribution, Vec layout, PetscInt blocksOnProcess, Mat *mat);
FLLOP_EXTERN PetscErrorCode MatLoadBinaryLocalBlocks(MPI_Comm comm, const char objName[], const MatType matType, MatInvType isblockdiag, PetscInt blocksOnProcess, MatFileDistType distribution, Mat *mat);
FLLOP_EXTERN PetscErrorCode MatSaveBinary(const char fullPath[], Mat mat);
FLLOP_EXTERN PetscErrorCode MatSaveBinaryByName(Mat mat);
FLLOP_EXTERN PetscErrorCode MatSaveBinaryLocal(MPI_Comm comm, Mat mat);
FLLOP_EXTERN PetscErrorCode MatSaveBinaryBlockDiagSeq(MPI_Comm comm, Mat mat, const char objName[]);

FLLOP_EXTERN PetscErrorCode FllopASCIILoad_K_loc(MPI_Comm comm, Mat *K_loc);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_R_loc(MPI_Comm comm, Mat *R_loc);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_B_loc(MPI_Comm comm, PetscInt N,  Mat *B_loc);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_f_loc(MPI_Comm comm, Vec *f_loc);

FLLOP_EXTERN PetscErrorCode FllopASCIILoad_K(MPI_Comm comm, Mat *K);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_R(MPI_Comm comm, Mat *R);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_B(MPI_Comm comm, Mat K,  Mat *B);
FLLOP_EXTERN PetscErrorCode FllopASCIILoad_f(MPI_Comm comm, Vec *f);

#endif
