#if !defined(__FLLOPPC_H)
#define	__FLLOPPC_H
#include <petscpc.h>
#include "permonqps.h" 

/* subclasses */
#define PCQPS "qps"
#define PCDUAL "dual"

FLLOP_EXTERN PetscErrorCode FllopPCRegisterAll();
FLLOP_EXTERN PetscBool FllopPCRegisterAllCalled;

/* PCQPS type-specific functions */
FLLOP_EXTERN PetscErrorCode PCQPSGetIterationNumber(PC pc,PetscInt *it);
FLLOP_EXTERN PetscErrorCode PCQPSGetQP(PC pc,QP *qp);
FLLOP_EXTERN PetscErrorCode PCQPSGetQPS(PC pc,QPS *qps);
FLLOP_EXTERN PetscErrorCode PCQPSGetUseQPOperator(PC pc,PetscBool *flg);
FLLOP_EXTERN PetscErrorCode PCQPSSetQP(PC pc,QP qp);
FLLOP_EXTERN PetscErrorCode PCQPSSetQPS(PC pc,QPS qps);
FLLOP_EXTERN PetscErrorCode PCQPSSetUseQPOperator(PC pc,PetscBool flg);

/* PCDUAL type-specific functions */
typedef enum {PC_DUAL_NONE=0, PC_DUAL_LUMPED=1, PC_DUAL_DIRICHLET=2, PC_DUAL_DIRICHLET_DIAG=3, PC_DUAL_LUMPED_FULL=4} PCDualType;
FLLOP_EXTERN const char *PCDualTypes[];
FLLOP_EXTERN PetscErrorCode PCDualSetType(PC pc,PCDualType type);
FLLOP_EXTERN PetscErrorCode PCDualGetType(PC pc,PCDualType *type);

#endif

