#define EXTERN

#include "mpi.h"
#include "pglobalc.h"
#include "psolverc.h"
#include "pmetrinit.h"

#include "seqfilesm.h"
#include "seqfilest.h"
#include "seqfilesc.h"

#include <stdio.h>
#include <string.h>
#include <time.h>

int main (int argc, char *argv[])
{
  time_t bt,et;
  stochdriver *stochdm;
  stochdm = new stochdriver;
  stochdrivert *stochdt;
  stochdt = new stochdrivert;
  long hod,min;
  double sec = clock();
  
  bt = time (NULL);
  
  //  MPI initiation
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&Myrank);
  MPI_Comm_size(MPI_COMM_WORLD,&Nproc);
  MPI_Get_processor_name(proc_namec,&nameLengthc);
  
  //  initiation of the code
  pmetr_init (argc,(const char **)argv,stochdm,stochdt);
  
  //  solution of the problem
  par_solve_metr_problem ();
  
  et = time (NULL);
  if (Myrank==0){
    fprintf (Outc,"\n\n\n Data about computation time \n");
    fprintf (Outc,"\n\n Total time of computation             %ld",et-bt);
  }

  sec = (clock() - sec) / (double)CLOCKS_PER_SEC;
  hod = (long)sec/3600;  sec -= hod*3600;
  min = (long)sec/60;    sec -= min*60;

  if (Myrank==0){
    fprintf (stdout,"\n ------------------------------------");
    fprintf (stdout,"\n Consumed time by PMETR %2ld:%02ld:%05.2f",hod,min,sec);
    fprintf (stdout,"\n ------------------------------------\n");
  }

  fprintf (stdout,"\n");  fprintf (stderr,"\n");
  //fclose (in);  
  fclose (Outc);


  MPI_Finalize ();
  
}
